config/routes.rb
Rails.application.routes.draw do
  get 'recruitments/index'

  match '/404', :to => "errors#not_found", :via => :all
  match '/500', :to => "errors#internal_server_error", :via => :all

  resources :notifications do
    put :read
    get :follow
  end
  put 'notifications/:project_id/read_all', to: 'notifications#read_all', as: 'notifications_read_all'
  get 'notifications_check' => 'notifications#check'

  mount Attachinary::Engine => '/attachinary'

  resources :goals
  resources :cycles
  devise_for :thinkers, :controllers => {
    :sessions      => 'thinkers/sessions',
    :registrations => 'thinkers/registrations',
    :notifications => 'notifications'
  }

  resources :password, only: [:edit, :update]
  resources :otp, only: [:show] do
    member do
      put :enable
      put :disable
      put :codes
    end
  end

  resources :workloads
  resources :statuses
  resources :dependences
  resources :thinkers do
    resources :skills, except: [:show, :update, :edit], controller: 'thinkers/skills'
    resources :notifications, except: [:new], controller: 'thinkers/notifications'
    resources :preferences, only: [:edit, :update], controller: 'thinkers/preferences', path: 'thinkers/preferences', shallow: true

    member do
      get :dashboard
    end
  end
  resources :licenses
  resources :languages
  resources :projects do
    member do
      put :contribute
      put :elect
      put :migrate
      put :suspend
      put :resume
    end

    resources :teams do
      member do
        get 'ban'
        get 'unban'
      end
    end

    resources :statistics, only: [:show], controller: 'projects/statistics'

    resources :releases, shallow: true
    resources :election_polls, shallow: true
    namespace :settings, :module => :projects do
      resources :links, :controller   => :settings_links, :only   => [:index, :create]
      resources :other, :controller   => :settings_other, :only   => [:index, :create]
      resources :release, :controller => :settings_release, :only => [:index, :create]
      resources :skills, :controller => :settings_skills, except: [:show, :update, :edit]
      resources :father, :controller => :settings_father, :only => [:index, :create, :destroy]
      resources :images, :controller => :settings_images, :only => [:index, :create]
      resources :contribution_types, :controller => :settings_contribution_types, :only => [:index, :create]
    end

    resources :sprints, shallow: true do
      resources :survey, only: [:index, :create, :new]
    end

    resources :recruitments, shallow: true do
      member do
        put :approve
        put :reopen
      end
    end

    resources :tasks, shallow: true do
      member do
        put :sprint
        put :release
        put :assign
        put :judge
        put :reopen
        put :give_up
      end

      resources :comments, only: [:create, :edit, :update, :destroy], shallow: true do
        resources :reasons, shallow: true

        member do
          get :approve
          get :like
        end
      end

      resources :operations, shallow: true, except: [:new, :show] do
        member do
          put :done
        end
      end

      resource :ratings, only: [:create], shallow: true
    end

    resources :goals, shallow: true do
      member do
        put :tasks_in_sprint
      end
    end
  end
  resources :start, only: [:index]
  resources :how_does_it_works
  resources :faqs

  root "start#index"

end

app/models/notification.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

class Notification < ActiveRecord::Base
  acts_as_paranoid

  belongs_to :thinker
  belongs_to :sprint
  belongs_to :project, -> { with_deleted }
  belongs_to :goal
  belongs_to :task, -> { with_deleted }

  scope :sorted_by, lambda { |sort_option|
    direction = (sort_option =~ /desc$/) ? 'desc' : 'asc'
    case sort_option.to_s
    when /^title_/
      # Simple sort on the name colums
      order("LOWER(projects.title) #{ direction }")
    else
      raise(ArgumentError, "Invalid sort option: #{ sort_option.inspect }")
    end
  }

  def self.user(thinker)
    where.not(thinker: thinker)
         .where(project: thinker.contributions
              .where('intensity > ?', Contribution.intensities[:nothing]).pluck(:project_id))
         .where.not(id: thinker.notifications.pluck(:id))
  end
end

app/controllers/notifications_controller.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

class NotificationsController < ApplicationController
  include NotificationsHelper
  include SmartListing::Helper::ControllerExtensions
  helper  SmartListing::Helper

  before_action :set_notification, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_thinker!

  # GET /notifications
  # GET /notifications.json
  def index
    notifications_scope = Notification
                          .user(current_thinker)
                          .order('project_id DESC')
                          .order('created_at DESC')

    notifications_scope = apply_filters(notifications_scope, params[:filters]) if params[:filters].present?

    @notifications = smart_listing_create :notifications,
                                          notifications_scope,
                                          partial: 'notifications/list'

    @notifications = @notifications.group_by { |n| [n.controller, n.model, n.model_id] }
  end

  # GET /notifications/1
  # GET /notifications/1.json
  def show
  end

  # GET /notifications/new
  def new
    @notification = Notification.new
  end

  # GET /notifications/1/edit
  def edit
  end

  # POST /notifications
  # POST /notifications.json
  def create
    @notification = Notification.new(notification_params)

    respond_to do |format|
      if @notification.save
        format.html { redirect_to @notification, notice: 'Notification was successfully created.' }
        format.json { render :show, status: :created, location: @notification }
      else
        format.html { render :new }
        format.json { render json: @notification.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /notifications/1
  # PATCH/PUT /notifications/1.json
  def update
    respond_to do |format|
      if @notification.update(notification_params)
        format.html { redirect_to @notification, notice: 'Notification was successfully updated.' }
        format.json { render :show, status: :ok, location: @notification }
      else
        format.html { render :edit }
        format.json { render json: @notification.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /notifications/1
  # DELETE /notifications/1.json
  def destroy
    @notification.destroy
    respond_to do |format|
      format.html { redirect_to notifications_url, notice: 'Notification was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  # PATCH/PUT /notifications/1/read
  # PATCH/PUT /notifications/1/read.json
  def read
    @notification = Notification.find(params[:notification_id])

    mark_as_read_similar_notifications(@notification)

    respond_to do |format|
      format.html { redirect_to notifications_url, notice: 'Notification read.' }
      format.json { head :no_content }
    end
  end

  # PATCH/PUT /notifications/1/read_all
  # PATCH/PUT /notifications/1/read_all.json
  def read_all
    project = Project.with_deleted.friendly.find(params[:project_id])
    @notifications = Notification.where(project: project)

    current_thinker.notifications << @notifications
    respond_to do |format|
      format.html { redirect_to notifications_url, notice: 'All notifications read.' }
      format.json { head :no_content }
    end
  end

  def check
    @icon = 'fa-lg'
    @icon = 'fa-2x' if params[:small] == 'true'

    respond_to do |format|
      format.js { render layout: false }
    end
  end

  def follow
    notification = Notification.find(params[:notification_id])

    mark_as_read_similar_notifications(notification)

    respond_to do |format|
      format.html { redirect_to url_for_notifications(notification), notice: 'Notification mark as read.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_notification
    @notification = Notification.find(params[:id])
  end

  def mark_as_read_similar_notifications(notification)
    similar_notifications = Notification
                            .user(current_thinker)
                            .where(project: notification.project)
                            .where(controller: notification.controller)
                            .where(model: notification.model)
                            .where(model_id: notification.model_id)

    current_thinker.notifications << notification
    similar_notifications.each do |s_notification|
      current_thinker.notifications << s_notification
    end
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def notification_params
    params.require(:notification).permit(:project_id, :thinker_id)
  end
end

app/controllers/thinkers/notifications_controller.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

class Thinkers::NotificationsController < ApplicationController
  before_action :set_thinker
  before_action :authenticate_thinker!
  before_action :check_owner!

  def index
  end

  private

  def set_thinker
    @thinker = Thinker.friendly.find(params[:thinker_id])
  end
end

app/helpers/notifications_helper.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

module NotificationsHelper
  def url_for_notifications(notification)
    if notification.controller == 'comments'
      comment_klass = notification.model.constantize
      comment = comment_klass.find(notification.model_id)

      return url_for(:controller => 'tasks', :action => 'show', :id => comment.task.id)
    elsif notification.controller == 'operations'
      operation_klass = notification.model.constantize
      operation = operation_klass.find(notification.model_id)

      return url_for(:controller => 'operations', :action => 'index', :task_id => operation.task.id)
    elsif notification.controller == 'assigned_roles' or notification.controller == 'elections'
      assigned_role_klass = notification.model.constantize
      assigned_role = assigned_role_klass.find(notification.model_id)

      return url_for(:controller => 'teams', :action => 'index', :project_id => assigned_role.project.id)
    end

    url_for(:controller => notification.controller, :action => 'show', :id => notification.model_id)
  end

  def icon_for(notification)
    case notification.action
    when 'create'
      icon('plus-circle', class: 'fa-lg fa-fw')
    when 'update'
      icon('refresh', class: 'fa-lg fa-fw')
    when 'destroy'
      icon('remove', class: 'fa-lg fa-fw')
    else
      icon('bolt', class: 'fa-lg fa-fw')
    end
  end

  def title_for(notification)
    model = Object.const_get(notification.model)
    if model.try(:with_deleted)
      model = model.try(:with_deleted).find_by_id notification.model_id
    else
      model = model.find_by_id notification.model_id
    end

    t "notifications.list.#{notification.controller}.#{notification.action}",
      case notification.controller
      when 'tasks', 'recruitments'
        {
          thinker: notification.thinker.name,
          task: model.title
        }
      when 'goals'
        {
          thinker: notification.thinker.name,
          goal: model.title
        }
      when 'operations', 'comments'
        {
          thinker: notification.thinker.name,
          task: model.task.title
        }
      when 'sprints'
        {
          serial: model.serial,
          total: model.obtained
        }
      when 'projects'
        {
          thinker: notification.thinker.name
        }
      when 'releases'
        {
          thinker: notification.thinker.name,
          release: model.version
        }
      when 'assigned_roles'
        assigned_role_klass = notification.model.constantize
        assigned_role = assigned_role_klass.find(notification.model_id)

        {
          thinker: assigned_role.thinker.name,
          team_role: t("team_roles.#{assigned_role.team_role.t_name}")
        }
      when 'elections'
        election_poll_klass = notification.model.constantize
        election_poll = election_poll_klass.find(notification.model_id)

        {
          status: election_poll.status
        }
      end
  end

  def notification_icon(notifications, dimension = 'fa-lg')
    if notifications.empty?
      icon('comments', class: "#{dimension} notification-icon dark-grey")
    else
      icon('commenting', class: "#{dimension} notification-icon dark-grey")
    end
  end
end

app/helpers/thinkers/notifications_helper.rb
# This file is part of Thinks.

# Thinks is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Thinks is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero Public License for more details.

# You should have received a copy of the GNU Affero Public License
# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) 2015, Claudio Maradonna

module Thinkers::NotificationsHelper
end

app/views/notifications/_form.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

= form_for @notification do |f|
  - if @notification.errors.any?
    #error_explanation
      %h2= "#{pluralize(@notification.errors.count, "error")} prohibited this notification from being saved:"
      %ul
        - @notification.errors.full_messages.each do |msg|
          %li= msg

  .field
    = f.label :project_id
    = f.number_field :project_id
  .field
    = f.label :thinker_id
    = f.number_field :thinker_id
  .actions
    = f.submit 'Save'

app/views/notifications/_list.html.erb
<!-- This file is part of Thinks. -->

<!-- Thinks is free software: you can redistribute it and/or modify -->
<!-- it under the terms of the GNU Affero Public License as published by -->
<!-- the Free Software Foundation, either version 3 of the License, or -->
<!-- (at your option) any later version. -->

<!-- Thinks is distributed in the hope that it will be useful, -->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of -->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
<!-- GNU Affero Public License for more details. -->

<!-- You should have received a copy of the GNU Affero Public License -->
<!-- along with Thinks.  If not, see <http://www.gnu.org/licenses/>. -->

<!-- Copyright (c) 2015, Claudio Maradonna -->

<h1 class="chapter-title">
  <%= t('.notifications') %>
</h1>
<%- project_id = nil %>
<div class="panel panel-default">
    <% if @notifications.empty? %>
        <ul class="list-group">
            <li class="list-group-item">
                <%= t ".no_notifications_found" %>
            </li>
        </ul>
    <% else %>
        <% counter = 0 %>
          <% @notifications.each do |index_group, notification_group| %>
            <% counter += 1 %>
            <% notification_group.each_with_index do |notification, index| %>
                <% if notification.project.id != project_id %>
                    <% if !project_id.nil? %>
                        </ul>
                    <% end %>
                    <% project_id = notification.project.id %>
                    <div class="panel-heading">
                        <strong>
                            <%= link_to notification.project.title, project_path(notification.project) %>
                        </strong>
                        <%= link_to notifications_read_all_path(notification.project), :class => "pull-right fa-fw", :method => :put do %>
                            <%= icon('check') %>
                        <% end %>
                    </div>
                    <ul class="list-group">
                <% end %>

                <% if notification_group.count > 1 && index == 1 %>
                    <div class="collapse" id="collapseNotificationGroup<%= counter %>">
                <% end %>

                <li class="list-group-item">
                    <%= icon_for(notification) %>
                    <% if notification.project.deleted? %>
                        <%= title_for(notification) %>
                    <% else %>
                        <%= link_to (notification_follow_path(notification)) do %>
                            <%= title_for(notification) %>
                        <% end %>
                    <% end %>
                    <%= link_to notification_read_path(notification), :class => "pull-right fa-fw", :method => :put do %>
                        <%= icon('check') %>
                    <% end %>
                    <small class="help-block" style="margin-left: 28px; margin-bottom: 0; margin-top: 0;">
                        <%= notification.created_at.ago_in_words %>
                    </small>
                    <% if notification_group.count > 1 && index == 0 %>
                        <a role="button" data-toggle="collapse" aria-expanded="false" aria-controls="collapseNotificationGroup<%= counter %>" href="#collapseNotificationGroup<%= counter %>">
                            <small class="help-block" style="margin-left: 28px; margin-bottom: 0;">
                                <% number_of_other_notifications = notification_group.count - 1 %>
                                <%= pluralize number_of_other_notifications, "other notification", "other notifications" %>

                                    <strong>...</strong>
                            </small>
                        </a>
                    <% end %>
                </li>

                <% if notification_group.count > 1 && (index + 1) == notification_group.count %>
                    </div>
                <% end %>

            <% end %>
        <% end %>
    <% end %>
</div>

app/views/notifications/check.js.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

$('.notification-icon').replaceWith("#{escape_javascript(notification_icon(Notification.user(current_thinker), @icon))}")

app/views/notifications/edit.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%h1 Editing notification

= render 'form'

= link_to 'Show', @notification
\|
= link_to 'Back', notifications_path

app/views/notifications/index.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

= smart_listing_render :notifications

app/views/notifications/new.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%h1 New notification

= render 'form'

= link_to 'Back', notifications_path

app/views/notifications/show.html.haml
-# This file is part of Thinks.

-# Thinks is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.

-# Thinks is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero Public License for more details.

-# You should have received a copy of the GNU Affero Public License
-# along with Thinks.  If not, see <http://www.gnu.org/licenses/>.

-# Copyright (c) 2015, Claudio Maradonna

%p#notice= notice

%p
  %b Project:
  = @notification.project_id
%p
  %b Thinker:
  = @notification.thinker_id

= link_to 'Edit', edit_notification_path(@notification)
\|
= link_to 'Back', notifications_path